/**
 * Handle: expandoo
 * Version: 0.0.1
 * Deps: $jq
 * Enqueue: true
 */

jQuery(function($) {
    
    $.extend({
        expandoo_class    : "expandoo",
        expandoo_closest  : "div.entry-content",
        expandoo_expand   : "parent",
        expandoo_pixel    : "400",
        expandoo_selector : "img.expandoo",
        expandoo_shadow   : "0",
        expandoo_speed    : "800",
        expandoo_use      : "class",
        expandoo_offset_t : "0",
        expandoo_offset_l : "0",
        expandoo_color    : "#000",
        expandoo_3d       : "off",
        expandoo_tooltip  : "off",
        expandoo_tt_text  : "custom",
        expandoo_tt_mini  : "Click to minimize",
        expandoo_tt_maxi  : "Click to expand"
    }, expandoo_options);
    
    
    var selector = expandoo_options.expandoo_use == 'custom' ? expandoo_options.expandoo_selector :
                   expandoo_options.expandoo_use == 'img' ? 'img' : '.'+expandoo_options.expandoo_class;
    
    $(selector).each(function() {
        $(this).data('width', $(this).width());
    }).on('click', function() {
        
        var self          = this,
            data_parent   = $(this).data('parent'),
            data_maxwidth = $(this).data('maxwidth'),
            data_speed    = $(this).data('speed'),
            parent        = $(this).parent(),
            has_caption   = $(this).closest('.wp-caption').length > 0,
            flag          = $(this).data('flag'),
            m_width, speed;
            
        if (data_parent && $.trim(data_parent).length && $($.trim(data_parent)).length) {
            parent = $($.trim(data_parent));
        }else if ( expandoo_options.expandoo_expand == 'closest' ) {
            parent = $(this).closest(expandoo_options.expandoo_closest);
        }else if ( has_caption ) {
            parent = parent.parent();
        }
        
        if (data_maxwidth && !isNaN(data_maxwidth.replace('px',''))) {
            m_width = parseInt( data_maxwidth.replace('px',''), 10 );
        }else if ( expandoo_options.expandoo_expand == 'pixel' ) {
            m_width = parseInt( expandoo_options.expandoo_pixel, 10 );
        }else{
            m_width = parent.width();
        }
        
        if (m_width - $(this).data('width') < 10) m_width = $(this).closest('article').width();
            
        if (data_speed && !isNaN(data_speed)) {
            speed = data_speed;
        }else{
            speed = parseInt( expandoo_options.expandoo_speed, 10 );
        }
                
        var ani        = has_caption ? $(this).add( $(this).closest('.wp-caption') ) : $(this),
            shadow_ani = has_caption ? $(this).closest('.wp-caption') : $(this);
        
        shadow_ani.box = flag ? 0 : expandoo_options.expandoo_shadow;
        if ( expandoo_options.expandoo_3d == 'on' ) {
            shadow_ani.eff = flag ? 10 : 0;
            shadow_ani.eff_too = flag ? 0 : 10;
            $(shadow_ani).css({
                '-webkit-transform-style' : 'preserve-3d',
                '-moz-transform-style'    : 'preserve-3d',
                '-ms-transform-style'     : 'preserve-3d',
                'transform-style'         : 'preserve-3d',
                '-webkit-perspective'     : (m_width*50) + 'px',
                '-moz-perspective'        : (m_width*50) + 'px',
                '-ms-perspective'         : (m_width*50) + 'px',
                'perspective'             : (m_width*50) + 'px'
            })
        }else{
            shadow_ani.eff = 0;
            shadow_ani.eff_too = 0;
        }
        
        
        
        ani.stop(true, false).animate({
            width: (flag ? $(this).data('width') : m_width),
        }, {
            duration: speed,
            easing : expandoo_options.expandoo_easing,
            queue: false,
            complete : function() {
                $(self).toggleClass('expanded', !flag);
                if (expandoo_options.expandoo_tt_text == 'custom') {
                    var on  = expandoo_options.expandoo_tt_maxi,
                        off = expandoo_options.expandoo_tt_mini;
                        
                    $('.expandoo_tooltip').text(function() {
                        return flag ? off : on;
                    });
                }
            }
        });
        
        shadow_ani.animate({
            box : (flag ? 0 : expandoo_options.expandoo_shadow),
            eff : shadow_ani.eff_too
        }, {
            duration: speed,
            easing : expandoo_options.expandoo_easing,
            queue: false,
            step: function(now, fx) {
                if (fx.prop == 'box') {
                    if (fx.start != fx.end) {
                        now = Math.round(now);
                        fx.elem.box = now;
                        var percT = (now * expandoo_options.expandoo_offset_t) / 100,
                            percL = (now * expandoo_options.expandoo_offset_l) / 100;
                        $(fx.elem).css({boxShadow: percL+'px '+percT+'px ' + now + 'px '+expandoo_options.expandoo_color});
                    }
                }else if (fx.prop == 'eff') {
                    fx.elem.eff = now;
                    if (fx.start != fx.end) {
                        var val = now < 5 ? now : Math.abs(now - 10);
                        
                        var x = ~(now*(val+(val*0.3)))+1,
                            y = now*(val+(val*0.8)),
                            z = (now*(val+(val*0.1)));
                            
                        $(fx.elem).css({
                         '-webkit-transform': 'rotateX(' + x + 'deg) rotateY(' + y + 'deg)  rotateZ(' + z + 'deg)',
                            '-moz-transform': 'rotateX(' + x + 'deg) rotateY(' + y + 'deg)  rotateZ(' + z + 'deg)',
                             '-ms-transform': 'rotateX(' + x + 'deg) rotateY(' + y + 'deg)  rotateZ(' + z + 'deg)',
                                 'transform': 'rotateX(' + x + 'deg) rotateY(' + y + 'deg)  rotateZ(' + z + 'deg)'
                        });
                    }
                }
            }
        });
        
        $(this).data('flag', !flag);
    });
    
    var timer;
    
    if (expandoo_options.expandoo_tooltip !== "off") {
        
        $('<div />', {
            'class'  : 'expandoo_tooltip',
            css : {
                position : 'fixed',
                display  : 'none'
            }
        }).appendTo('body');
        
        $(selector).on({
            mouseenter: function(e) {
                if (expandoo_options.expandoo_tt_text == 'custom') {
                    var on  = expandoo_options.expandoo_tt_maxi,
                        off = expandoo_options.expandoo_tt_mini;
                }else{
                    var on='', off='';
                    if (expandoo_options.expandoo_tt_text == 'alt') {
                        on = $(this).attr('alt');
                    }else if (expandoo_options.expandoo_tt_text == 'title') {
                        on = $(this).attr('title');
                    }else if (expandoo_options.expandoo_tt_text == 'caption') {
                        on = $.trim($(this).closest('.wp-caption').find('.wp-caption-text').text());
                    }
                    off = on;
                }
                $('.expandoo_tooltip').text($(this).hasClass('expanded') ? on : off).css({
                    top  : (e.pageY - $(window).scrollTop()) - 70,
                    left : (e.pageX - $(window).scrollLeft()) - 20,
                }).stop(true, false).delay(400).fadeIn('fast');
            },
            mousemove: function(e) {
                $('.expandoo_tooltip').css({
                    top  : (e.pageY - $(window).scrollTop()) - 70,
                    left : (e.pageX - $(window).scrollLeft()) - 20
                });
            },
            mouseleave: function(e) {
                timer = setTimeout(function() {
                    $('.expandoo_tooltip').fadeOut('fast');
                }, 200);
            }
        });
        
        $(document).on({
            mouseenter: function() {
                clearTimeout(timer);
            },
            mousemove: function(e) {
                $('.expandoo_tooltip').css({
                    top  : (e.pageY - $(window).scrollTop()) - 70,
                    left : (e.pageX - $(window).scrollLeft()) - 20,    
                });
            }
        }, '.expandoo_tooltip');
        
    }
});