<?php
/*
Plugin Name: Expandoo by Played
Plugin URI: http://played.no/expandoo/
Description: Expand images when clicked
Version: 1.0.1
Author: Played Interactive
Author URI: http://played.no
License: GPLv2 or later
*/

define('EXPANDOO', plugin_dir_url( __FILE__ ));


if ( !function_exists( 'add_action' ) ) {
    echo "This is just a plugin that expands stuff";
    exit;
}

add_action( 'admin_menu', 'expandoo_admin' );
add_action( 'admin_enqueue_scripts', 'wp_enqueue_color_picker' );

function wp_enqueue_color_picker( $hook_suffix ) {
    wp_enqueue_style( 'wp-color-picker' );
    wp_enqueue_script( 'wp-color-picker');
    
    wp_register_script( 'expandoo_admin', plugins_url('admin.js', __FILE__), array( 'wp-color-picker' ), false, true );
    wp_localize_script( 'expandoo_admin', 'expandoo_options', array(
        'expandoo_class' => get_option( 'expandoo_class', "expandoo")
    ));
    wp_enqueue_script( 'expandoo_admin' );
}

wp_register_style( 'expandoo_css', plugins_url('expandoo.css', __FILE__));
wp_enqueue_style( 'expandoo_css' );

function expandoo_admin() {
    add_plugins_page('Expandoo', 'Expandoo', 'read', 'expandoo', 'expandoo_admin_show');
}

function expandoo_admin_show() {
    require_once dirname( __FILE__ ) . '/admin.php';    
}

$easing = get_option( 'expandoo_easing', "linear" );

wp_register_script( 'expandoo', plugins_url('expandoo.js', __FILE__), array('jquery'));

//delete_option('expandoo_class');
    //delete_option('expandoo_custom');
    //delete_option('expandoo_selector');
    //delete_option('expandoo_expand');
    //delete_option('expandoo_closest');
    //delete_option('expandoo_pixel');
    //delete_option('expandoo_speed');
    //delete_option('expandoo_shadow');

wp_localize_script( 'expandoo', 'expandoo_options', array(
    'expandoo_use'      => get_option( 'expandoo_selector', "class"),
    'expandoo_class'    => get_option( 'expandoo_class', "expandoo"),
    'expandoo_selector' => get_option( 'expandoo_custom', "img.expandoo"),
    'expandoo_expand'   => get_option( 'expandoo_expand', "parent" ),
    'expandoo_closest'  => get_option( 'expandoo_closest', "div.entry-content"  ),
    'expandoo_pixel'    => get_option( 'expandoo_pixel', "400" ),
    'expandoo_speed'    => get_option( 'expandoo_speed', "800" ),
    'expandoo_shadow'   => get_option( 'expandoo_shadow', "0" ),
    'expandoo_offset_t' => get_option( 'expandoo_offset_t', "0" ),
    'expandoo_offset_l' => get_option( 'expandoo_offset_l', "0" ),
    'expandoo_color'    => get_option( 'expandoo_color', "#000" ),
    'expandoo_3d'       => get_option( 'expandoo_effect', "off" ),
    'expandoo_easing'   => $easing,
    'expandoo_tooltip'  => get_option( 'expandoo_tooltip', "off" ),
    'expandoo_tooltip'  => get_option( 'expandoo_tooltip', "off" ),
    'expandoo_tt_text'  => get_option( 'expandoo_tooltip_text', "custom" ),
    'expandoo_tt_mini'  => get_option( 'expandoo_tooltip_mini', "custom" ),
    'expandoo_tt_maxi'  => get_option( 'expandoo_tooltip_maxi', "custom" )
    
));

if ( ! ($easing=='linear' || $easing =='swing' ) ) {
    wp_enqueue_script( 'jquery-effects-core' );
}

wp_enqueue_script( 'expandoo' );

add_filter( 'image_send_to_editor', 'expandoo_image', 10, 7);
function expandoo_image($html, $id, $alt, $title, $align, $url, $size ) {
    $expandoo_class = get_option( 'expandoo_class' , "expandoo");
    
    $dom = new DOMDocument();
    @$dom->loadHTML($html);
    $x = new DOMXPath($dom);
    $out = '';
    $expandoo = false;
 
    foreach($x->query("//img[@src]") as $node) {
        $classes = $node->getAttribute("class");
        if (strstr($classes, $expandoo_class)) {
           $expandoo = true;
           $node->setAttribute("class", str_replace("_".$expandoo_class, " ".$expandoo_class, $classes));
        }
        $out .= $dom->saveHTML($node);
    }
    $newHtml = $out;
     
    return $expandoo ? $newHtml : $html;
}


add_filter( 'image_send_to_editor', 'expandoo_image2', 21, 8 );
function expandoo_image2( $html, $id, $caption, $title, $align, $url, $size, $alt ) {
    $expandoo_class = get_option( 'expandoo_class' , 'expandoo');
	return str_replace("_".$expandoo_class, "", $html);
}


?>